// Funciona

 import nslj.src.system.*; 
 import nslj.src.cmd.*; 
 import nslj.src.lang.*; 
 import nslj.src.math.*; 
 import nslj.src.display.*; 

 public class MHM extends NslModule /*(int tectsize)*/ 
{
	public NslDinDouble1 baf ; /*(tectsize)*/			
	public NslDouble1 in ; /*(tectsize)*/
	public NslDinDouble1 gapsf ; /*(tectsize)*/
	public NslDinDouble1 preyHorF ; /*(tectsize)*/			
	public NslDoutDouble1 mhm ; /*(tectsize)*/
	//public NslDoutDouble0 ps();
	public NslDoutDouble0 ps ; /*()*/
	public NslDouble0 d_norm ; /*()*/
	public NslDouble0 d_mhm ; /*()*/
	public NslDinDouble0 pspa ; /*()*/
	public NslDinDouble0 psoa ; /*()*/
	private NslDouble1 mhm_hat ; /*(tectsize)*/		// Predictive MHM.
	private NslDouble0 field_a ; /*()*/
	private NslDouble0 field_center ; /*()*/
	private NslDouble0 rspa ; /*()*/
	private NslDouble0 rsoa ; /*()*/
        
        //bandera para centrar presa rodolfo 16/01/2004
        private boolean bandera;

	public  void initSys()
	{
		rspa.set(1.0);	
		rsoa.set(1.0);	
		ps.set(0);
                d_norm.set(0.35); //aprendizaje 0.35, normal 1
                d_mhm.set(1); //valor temporal para aprendizaje
                
                bandera = true;
	}

	public  void simRun()
	{
		// Dynamics of Motor Heading Map (MHM): integrating several fields.
		// New fields can also be added while learning.

                
		if (
 nslj.src.math.NslGtr.eval(d_mhm.get(),d_norm.get()))
		{			 
			(baf).set(field_center.getint(),field_a);
			in.set(baf); // New Field "inserted"
                        //System.out.println("New Field inserted");
		}
		else
			in.set(0); // reset input (cf. antidromic
		
                //in.print();
                //System.out.println("d_norm: "+  d_norm.toString());
                //System.out.println("d_mhm: "+d_mhm.toString());
		mhm_hat.set(mhm);					// Predictive MHM.
                
                if(bandera) {
                    System.out.println("-----NORMAL-----");
		mhm.set(
 __nsltmp103=nslj.src.math.NslAdd.eval(__nsltmp103,
 __nsltmp102=nslj.src.math.NslAdd.eval(__nsltmp102,
 __nsltmp101=nslj.src.math.NslAdd.eval(__nsltmp101,gapsf.get(),preyHorF.get()),baf.get()),in.get()));		// Fields over MHM.		
                } else {
                    System.out.println("-----CORRECCION-----");
                    mhm.set(preyHorF.get());
                }
                bandera = !bandera;

		ps.set((
 nslj.src.math.NslAdd.eval(ps.get(),
 nslj.src.math.NslElemMult.eval(rspa.get(),pspa.get())))+(
 nslj.src.math.NslElemMult.eval(rsoa.get(),psoa.get())));   		
   		ps.set(NslSigmoid.eval(ps,-(1.0),1.0,-(1.0),1.0)) /* rule 108 */;	
	}
	/* nslInitTempModule inserted by NPP */
public void nslInitTempModule() {
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	__nsltmp101 = new double[1];
	__nsltmp102 = new double[1];
	__nsltmp103 = new double[1];
	/* end of automatic instantiation statements */
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempRun inserted by NPP */
public void nslInitTempRun() {
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	for (int i = 0; i < __nsltmp101.length; i++) {
		__nsltmp101[i] = 0;
}
	for (int i = 0; i < __nsltmp102.length; i++) {
		__nsltmp102[i] = 0;
}
	for (int i = 0; i < __nsltmp103.length; i++) {
		__nsltmp103[i] = 0;
}
	/* end of automatic intialisation statements */
}

	/* nslInitTempTrain inserted by NPP */
public void nslInitTempTrain() {
	/* Initialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* Declaration statements generated by NslPreProcessor */
	/* makeinst() declared variables */
	/* temporary variables */
	private  double[] __nsltmp101;
	private  double[] __nsltmp102;
	private  double[] __nsltmp103;
	/* constructor and related methods */
	/* nsl declarations */
	int tectsize;

	 /*GENERIC CONSTRUCTOR:   */
	 public MHM(String nslName, NslModule nslParent,int tectsize) {
		super(nslName, nslParent);
		this.tectsize = tectsize;
		
                //by rodolfo 09/2002
                makeInst(nslName, nslParent,tectsize);
                initSys();
		
	}
	public void makeInst(String nslName, NslModule nslParent,int tectsize){ 
	 baf=new NslDinDouble1 ("baf",this,tectsize); //NSLDECLS 
	 in=new NslDouble1 ("in",this,tectsize); //NSLDECLS 
	 gapsf=new NslDinDouble1 ("gapsf",this,tectsize); //NSLDECLS 
	 preyHorF=new NslDinDouble1 ("preyHorF",this,tectsize); //NSLDECLS 
	 mhm=new NslDoutDouble1 ("mhm",this,tectsize); //NSLDECLS 
	 ps=new NslDoutDouble0 ("ps",this); //NSLDECLS 
	 d_norm=new NslDouble0 ("d_norm",this); //NSLDECLS 
	 d_mhm=new NslDouble0 ("d_mhm",this); //NSLDECLS 
	 pspa=new NslDinDouble0 ("pspa",this); //NSLDECLS 
	 psoa=new NslDinDouble0 ("psoa",this); //NSLDECLS 
	 mhm_hat=new NslDouble1 ("mhm_hat",this,tectsize); //NSLDECLS 
	 field_a=new NslDouble0 ("field_a",this); //NSLDECLS 
	 field_center=new NslDouble0 ("field_center",this); //NSLDECLS 
	 rspa=new NslDouble0 ("rspa",this); //NSLDECLS 
	 rsoa=new NslDouble0 ("rsoa",this); //NSLDECLS 
	}
	/* end of automatic declaration statements */
}
